/* Evolucin diferencial */

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <values.h>
#include "randfunc.h"
#include "probl01.h"

#define ARMADURA 0
#define TAMPOBL 100

struct espaciocreencias {
	struct individuo situacional;
	double normativo[VARIABLES][4];
	double maxdifant[VARIABLES];
	double maxdifact[VARIABLES];
//	struct nodo kdtree;
};

//struct nodo {
//};

void poblacionInic(struct individuo*, double*, double*);
void creenciasInic(struct espaciocreencias*, struct individuo*, double*, double*);
void copiaind(struct individuo*, struct individuo*);
void extremos(int*, int*, struct individuo*);
void checkfact(struct individuo*, int);
void generaHijo(int, struct individuo*, struct espaciocreencias*, double, double, struct individuo*);
void update(struct espaciocreencias*, struct individuo*, int);
int compInd(const void *, const void *);

double media;

main(int argc, char **argv) {
	char cadena[50];
	int i, j, indmin, indmax, reemplaza;
	long Gmax, gen, evs = 0;
	double semilla, limi[VARIABLES], lims[VARIABLES], cr = 1, f = 0.5;
	FILE *a;
	struct individuo pobl[TAMPOBL + 3], temp;
	struct espaciocreencias blfs;

	if (argc == 4) {
		Gmax = atoi(argv[1]);
		semilla = atof(argv[2]);
		strcpy(cadena, argv[3]);
	}
	else {
		printf("Teclee el nmero mximo de generaciones: ");
		scanf("%d", &Gmax);
		printf("Teclee la semilla de aleatorios (0..1): ");
		scanf("%lf", &semilla);
		printf("Teclee el nombre del archivo de salida: ");
		scanf("%s", cadena);
	}

	if ( (a = fopen(cadena, "w")) == NULL ) {
		printf("Error al abrir el archivo de salida.\n");
		return (1);
	}
	fprintf(a, "Nmero mximo de generaciones: %d\n", Gmax);
	fprintf(a, "Semilla de aleatorios %lf\n\n", semilla);

	/* Inicializa aleatorios */
	randomizef(semilla);
	initrandomnormaldeviate();

	/* Almacena los lmites de las variables */
	limites(limi, lims);

	/* Crea una poblacin inicial aleatoria */
	poblacionInic(pobl, limi, lims);

	checkfact(pobl, 1);

	/* Se evala la aptitud de cada individuo */
	for (i = 0; i < TAMPOBL; i++) {
		evalua(&(pobl[i]));
		checkfact(&(pobl[i]), 0);
		evs++;
	}

	creenciasInic(&blfs, pobl, limi, lims);

	/* El ciclo principal, se ejecuta Gmax generaciones */
	for (gen = 0; gen < Gmax; gen++) {

		/* Ciclo para la generacin de hijos */
		for (i = 0; i < TAMPOBL; i++) {

			generaHijo(i, pobl, &blfs, cr, f, &temp);

			/* Revisar que el nuevo individuo no salga del dominio permitido */
			for (j = 0; j < VARIABLES; j++) {
				if (temp.x[j] < limi[j]) {
					temp.x[j] = rndreal(limi[j], lims[j]);
				}
				else if (temp.x[j] > lims[j]) {
					temp.x[j] = rndreal(limi[j], lims[j]);
				}
			}

			evalua(&temp);
			checkfact(&temp, 0);
			evs++;

			/* El hijo reemplaza al padre si tiene mejor aptitud */
			reemplaza = 0;
			if (temp.factible && pobl[i].factible) {
				if (temp.f <= pobl[i].f) {
					reemplaza = 1;
				}
			}
			else if (!(temp.factible) && !(pobl[i].factible)) {
				if (temp.viol <= pobl[i].viol) {
					reemplaza = 1;
				}
			}
			else if (temp.factible) {
				reemplaza = 1;
			}

			if (reemplaza) {
				copiaind(&(pobl[i]), &temp);
			}

		}

		update(&blfs, pobl, gen + 1);

		/* Impresin de los datos de la generacin */
		if (gen >= Gmax - 11 || (gen+1)%(Gmax/100) == 0) {
			extremos(&indmin, &indmax, pobl);
			fprintf(a, "Generacin %d\n", gen + 1);
			fprintf(a, "Aptitud media: %lf, aptitud mxima: %lf, aptitud mnima: %lf\n", media, pobl[indmax].f, pobl[indmin].f);
			fprintf(a, "Mejor individuo:");
			for (i = 0; i < VARIABLES; i++) {
				fprintf(a, " %lf,", pobl[indmin].x[i]);
			}
			fprintf(a, "\nEl mejor individuo ");
			if (!pobl[indmin].factible) {
				fprintf(a, "NO ");
			}
			fprintf(a, "es factible.\n");
			fprintf(a, "Evluaciones: %ld\n\n", evs);
		}

//		if (gen == 2499 || gen == 4999 || gen == 17499) { //20
//		if (gen == 999 || gen == 1999 || gen == 6999) { //50
		if (gen == 499 || gen == 999 || gen == 3499) { //100
//		if (gen == 249 || gen == 499 || gen == 1749) { //200
			printf("%lf\t", pobl[indmin].f);
		}

	}
//	printf("%lf\n", pobl[indmin].f);
	printf("\n");
	fclose(a);
	return (0);
}

void poblacionInic(struct individuo *pobl, double *limi, double *lims) {
	int i, j;

	for (i = 0; i < TAMPOBL; i++) {
		/* Para cada variable se elige un nmero real,
		   en el rango especificado */
		for (j = 0; j < VARIABLES; j++) {
			pobl[i].x[j] = rndreal(limi[j], lims[j]);
		}
	}
}

void creenciasInic(struct espaciocreencias *blfs, struct individuo *pobl, double limi[], double lims[]) {
	int i, j, indmin;
	double min;

	/* Inicializacin del conocimiento situacional */
	for (i = 0; !pobl[i].factible && i < TAMPOBL; i++);
	if (i < TAMPOBL) {
		min = pobl[i].f;
		indmin = i;
		for (; i < TAMPOBL; i++) {
			if (pobl[i].factible) {
				if (pobl[i].f < min) {
					indmin = i;
					min = pobl[i].f;
				}
			}
		}
	}
	else {
		min = pobl[0].viol;
		indmin = 0;
		for (i = 0; i < TAMPOBL; i++) {
			if (pobl[i].viol < min) {
				indmin = i;
				min = pobl[i].viol;
			}
		}
	}

	copiaind(&(blfs->situacional), &(pobl[indmin]));

	/* Inicializacin del conocimiento normativo */
	for (i = 0; i < VARIABLES; i++) {
		blfs->normativo[i][0] = limi[i];
		blfs->normativo[i][1] = lims[i];
		blfs->normativo[i][2] = blfs->normativo[i][3] = MAXFLOAT;

		blfs->maxdifant[i] = lims[i] - limi[i];
		blfs->maxdifact[i] = 0;
	}
}

void copiaind(struct individuo *dest, struct individuo *source) {
	int j;

	for (j = 0; j < VARIABLES; j++) {
		dest->x[j] = source->x[j];
	}

	dest->f = source->f;
	dest->viol = source->viol;
	dest->factible = source->factible;
}

/* Funcin para encontrar las aptitudes mnima y mxima de pobl */
void extremos(int *indmin, int *indmax, struct individuo *pobl) {
	int i, sumados = 0;
	float min, max, med = 0.0;

	/* Se prefieren soluciones factibles */
	for (i = 0; !pobl[i].factible && i < TAMPOBL; i++);
	if (i < TAMPOBL) {
		max = min = pobl[i].f;
		*indmin = *indmax = i;
		for (; i < TAMPOBL; i++) {
			if (pobl[i].factible) {
				if (pobl[i].f < min) {
					*indmin = i;
					min = pobl[i].f;
				}
				if (pobl[i].f > max) {
					*indmax = i;
					max = pobl[i].f;
				}
				med += pobl[i].f;
				sumados++;
			}
		}
	}
	else {
		max = min = pobl[0].viol;
		*indmin = *indmax = 0;
		for (i = 0; i < TAMPOBL; i++) {
			if (pobl[i].viol < min) {
				*indmin = i;
				min = pobl[i].viol;
			}
			if (pobl[i].viol > max) {
				*indmax = i;
				max = pobl[i].viol;
			}
			med += pobl[i].viol;
			sumados++;
		}
	}
	media = med/sumados;
}

/* Lmites para los valores permisibles de las variables.
   Funcin que cambia con el problema 
void limites(double limi[], double lims[]) {
	int i;

	limi[0] = 78.0;
	lims[0] = 102.0;
	limi[1] = 33.0;
	lims[1] = 45.0;
	for (i = 2; i < VARIABLES; i++) {
		limi[i] = 27.0;
		lims[i] = 45.0;
	}
}
*/
/* Evaluacin de la aptitud y de las restricciones.
   Funcin que cambia con el problema 
void evalua(struct individuo *ind) {
	int i;
	double t, f;

		
/* Rastrigin2D
	t = ind->x[0];
	f = t*t;
	t = ind->x[1];
	f += t*t;
	f += -cos(18*ind->x[0]) - cos(18*ind->x[1]);
*/
/* Floudas
	t = 1;
	for (i = 0; i < VARIABLES; i++) {
		t *= sin(ind->x[i]);
	}
	f = -5*t;
	t = 1;
	for (i = 0; i < VARIABLES; i++) {
		t *= sin(5*ind->x[i]);
	}
	f -= t;
*/
/* Easom
	t = ind->x[0] - M_PI;
	f = ind->x[1] - M_PI;
	f = -cos(ind->x[0])*cos(ind->x[1])*exp(-t*t - f*f);
/*
/* Bohachevsky 
	t = ind->x[0];
	f = t*t;
	t = ind->x[1];
	f += 2*t*t;
	f +=  -0.3*cos(3*M_PI*ind->x[0])*cos(4*M_PI*ind->x[1]) + 0.3;
*/
//	ind->f = f;
//}

/* Revisa si el individuo es factible y calcula la magnitud de su violacin */
void checkfact(struct individuo *ind, int inicializa) {
	int i;
	static double maxviol[NUMCONSTR];
	static double delta = 0.001; /* Para las restricciones de igualdad 0.001 0.01 0.0001 0.05 */

	if (ARMADURA) {
		return;
	}

	if (inicializa) {
		for (i = 0; i < NUMCONSTR; i++) {
			maxviol[i] = 0;
		}
		return;
	}

	ind->factible = 1;
	for (i = 0; i < NUMCONSTR; i++) {
		if (i < NUMCONSTR - NUMEQCONSTR) {
			if (ind->g[i] > 0) {
				ind->factible = 0;
				break;
			}
		}
		else {
			if (fabs(ind->g[i]) - delta > 0) {
				ind->factible = 0;
				break;
			}
		}
	}

	ind->viol = 0;
	if (!(ind->factible)) {
		for (i = 0; i < NUMCONSTR; i++) {
			if (i < NUMCONSTR - NUMEQCONSTR) {
				if (ind->g[i] > 0) {
					if (ind->g[i] > maxviol[i]) {
						maxviol[i] = ind->g[i];
					}
					ind->viol += ind->g[i]/maxviol[i];
				}
			}
			else {
				if (fabs(ind->g[i]) - delta > 0) {
					if (fabs(ind->g[i]) > maxviol[i]) {
						maxviol[i] = fabs(ind->g[i]);
					}
					ind->viol += fabs(ind->g[i])/maxviol[i];
				}
			}
		}
	}
}

void generaHijo(int i, struct individuo *pobl, struct espaciocreencias *blfs, double cr, double f, struct individuo *nuevo) {
	int r1, r2, r3, j, k;
	double randnum;

	/* Eleccin aleatoria de los individuos para
	   la cruza y la distribucin de la mutacin */
	do {
		r1 = rnd(0, TAMPOBL - 1);
	} while (r1 == i);
	do {
		r2 = rnd(0, TAMPOBL - 1);
	} while (r2 == i || r2 == r1);
	do {
		r3 = rnd(0, TAMPOBL - 1);
	} while (r3 == i || r3 == r1 || r3 == r2);

	for (j = 0; j < VARIABLES; j++) {
		if (fabs(pobl[r1].x[j] - pobl[r2].x[j]) > blfs->maxdifact[j]) {
			blfs->maxdifact[j] = fabs(pobl[r1].x[j] - pobl[r2].x[j]);
		}
	}

	randnum = randomperc();
	if (randnum < 0.5) {
		/* Cruza y mutacin
		   Versin DE/rand/1/bin */
		j = rnd(0, VARIABLES - 1);
		for (k = 1; k <= VARIABLES; k++) {
			if (randomperc() < cr || k == VARIABLES) {
				nuevo->x[j] = pobl[r3].x[j] + f*(pobl[r1].x[j] - pobl[r2].x[j]);
			}
			else {
				nuevo->x[j] = pobl[i].x[j];
			}

			j = (j + 1)%VARIABLES;
		}
	}

	else if (randnum < 0.5) {
		/* Operadores influidos por el conocimiento situacional */
		j = rnd(0, VARIABLES - 1);
		for (k = 1; k <= VARIABLES; k++) {
			if (randomperc() < cr || k == VARIABLES) {
				nuevo->x[j] = blfs->situacional.x[j] + f*(pobl[r1].x[j] - pobl[r2].x[j]);
			}
			else {
				nuevo->x[j] = pobl[i].x[j];
			}

			j = (j + 1)%VARIABLES;
		}
	}

	else /*if (randnum < 0.66)*/ {
		/* Operadores influidos por el conocimiento normativo */
		j = rnd(0, VARIABLES - 1);
		for (k = 1; k <= VARIABLES; k++) {
			if (randomperc() < cr || k == VARIABLES) {
				if (pobl[r3].x[j] < blfs->normativo[j][0]) {
					nuevo->x[j] = pobl[r3].x[j] + f*fabs(pobl[r1].x[j] - pobl[r2].x[j]);
				}
				else if (pobl[r3].x[j] > blfs->normativo[j][1]) {
					nuevo->x[j] = pobl[r3].x[j] - f*fabs(pobl[r1].x[j] - pobl[r2].x[j]);
				}
				else {
					nuevo->x[j] = pobl[r3].x[j] + (blfs->normativo[j][1] - blfs->normativo[j][0])/(blfs->maxdifant[j])*f*(pobl[r1].x[j] - pobl[r2].x[j]);
				}
			}
			else {
				nuevo->x[j] = pobl[i].x[j];
			}

			j = (j + 1)%VARIABLES;
		}
	}

//	else {
}

void update(struct espaciocreencias *blfs, struct individuo *pobl, int gen) {
	int i, j, indmin, indmax, actualizar, lowupd, upupd, accepted;
	double xmin, xmax;
	struct individuo sorted[TAMPOBL];
	static double fbest;
	static int fbestgens = 0, lastchange = 1;

	/* Funcin de aceptacin */

	/* Ordenar individuos */
	for (i = 0; i < TAMPOBL; i++) {
		copiaind(&(sorted[i]), &(pobl[i]));
	}
	qsort(sorted, TAMPOBL, sizeof(struct individuo), &compInd);

	/* Ver si cambi el mejor */
	if (sorted[0].f == fbest) {
		fbestgens++;
	}
	else {
		fbest = sorted[0].f;
		fbestgens = 0;
	}
	if (fbestgens > 20) {
		lastchange = gen;
//printf("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!%d %d\n", fbestgens, gen);
	}
	accepted = floor(0.2*TAMPOBL + 0.8*TAMPOBL/(gen - lastchange + 1));
//printf("%d\n", accepted);
	/* Actualizacin del conocimiento situacional */
	actualizar = 0;
	if (sorted[0].factible && blfs->situacional.factible) {
		if (sorted[0].f < blfs->situacional.f) {
			actualizar = 1;
		}
	}
	else if (!(sorted[0].factible) && !(blfs->situacional.factible)) {
		if (sorted[0].viol < blfs->situacional.viol) {
			actualizar = 1;
		}
	}
	else if (sorted[0].factible) {
		actualizar = 1;
	}

//printf("i\n");
	if (actualizar) {
		copiaind(&(blfs->situacional), &(sorted[0]));
	}
//printf("f\n");

	/* Actualizacin del conocimiento normativo */
	for (j = 0; j < VARIABLES; j++) {
		indmin = indmax = 0;
		xmin = xmax = sorted[0].x[j];
		for (i = 1; i < accepted; i++) {
			if (sorted[i].x[j] < xmin) {
				xmin = sorted[i].x[j];
				indmin = i;
			}
			if (sorted[i].x[j] > xmax) {
				xmax = sorted[i].x[j];
				indmax = i;
			}
		}

		lowupd = 0;
		/* expansion */
		if (xmin < blfs->normativo[j][0]) {
			lowupd = 1;
		}
		/* reduction */
		else {
			if (sorted[indmin].factible && sorted[indmin].f < blfs->normativo[j][2]) {
				lowupd = 1;
			}
		}

		upupd = 0;
		/* expansion */
		if (xmax > blfs->normativo[j][1]) {
			upupd = 1;
		}
		/* reduction */
		else {
			if (sorted[indmax].factible && sorted[indmax].f < blfs->normativo[j][3]) {
				upupd = 1;
			}
		}

		if (lowupd) {
			blfs->normativo[j][0] = xmin;
			blfs->normativo[j][2] = sorted[indmin].f;
		}
		if (upupd) {
			blfs->normativo[j][1] = xmax;
			blfs->normativo[j][3] = sorted[indmax].f;
		}
/*if (j == 0 && (lowupd || upupd)) {
printf("%lf %lf %d\n", blfs->normativo[0][0], blfs->normativo[0][1], gen);
}*/
	}

	for (i = 0; i < VARIABLES; i++) {
		blfs->maxdifant[i] = blfs->maxdifact[i];
		blfs->maxdifact[i] = 0;
	}
}

int compInd(const void *ind1, const void *ind2) {
	int dif;

	if ( ((struct individuo *)ind1)->factible && ((struct individuo *)ind2)->factible ) {
		if ( ((struct individuo *)ind1)->f < ((struct individuo *)ind2)->f ) {
			dif = -1;
		}
		else if ( ((struct individuo *)ind1)->f > ((struct individuo *)ind2)->f ) {
			dif = 1;
		}
		else {
			dif = 0;
		}
	}
	else if (!( ((struct individuo *)ind1)->factible ) && !( ((struct individuo *)ind2)->factible )) {
		if ( ((struct individuo *)ind1)->viol < ((struct individuo *)ind2)->viol ) {
			dif = -1;
		}
		if ( ((struct individuo *)ind1)->viol > ((struct individuo *)ind2)->viol ) {
			dif = 1;
		}
		else {
			dif = 0;
		}
	}
	else {
		dif = ((struct individuo *)ind2)->factible - ((struct individuo *)ind1)->factible;
	}

	return dif;
}
