/* Write in this file your function and constraints */

#define VARIABLES 13
#define NUMCONSTR 9
#define NUMEQCONSTR 0

struct individuo {
	double x[VARIABLES];
	double f;
	double g[NUMCONSTR];
	double viol;
	char factible;
};

void limites(double[], double[]);
void evalua(struct individuo *);

/* Dominio de las variables del problema */
void limites(double l[], double u[]) {
	int i;
	for (i = 0; i < 9; i++) {
		l[i] = 0.0;
		u[i] = 1.0;
	}
	for (i = 9; i < 12; i++) {
		l[i] = 0.0;
		u[i] = 100.0;
	}
	l[12] = 0.0;
	u[12] = 1.0;
}

/* Evaluacin de la aptitud y de las restricciones.
   Funcin que cambia con el problema */
void evalua(struct individuo *ind) {
	int i;
	float s1 = 0.0, s2 = 0.0, s3 = 0.0;
	float delta = 0.001; /* Para las restricciones de igualdad */


	/* Evaluate the objective function, and store its value in ind->aptitud.
	   Evaluate the constraints and store 1 in ind->factible if the point is feasible,
	   or 0 if it is infeasible.
	   Use the values stored in ind->x[i]. */


	for (i = 0; i < 4; i++) {
		s1 += ind->x[i];
		s2 += ind->x[i]*ind->x[i];
	}
	for (i = 4; i < 13; i++) {
		s3 += ind->x[i];
	}

	ind->f = 5*s1 - 5*s2 - s3;

	ind->g[0] = 2*ind->x[0] + 2*ind->x[1] + ind->x[9] + ind->x[10] - 10;
	ind->g[1] = 2*ind->x[0] + 2*ind->x[2] + ind->x[9] + ind->x[11] - 10;
	ind->g[2] = 2*ind->x[1] + 2*ind->x[2] + ind->x[10] + ind->x[11] - 10;
	ind->g[3] = -8*ind->x[0] + ind->x[9];
	ind->g[4] = -8*ind->x[1] + ind->x[10];
	ind->g[5] = -8*ind->x[2] + ind->x[11];
	ind->g[6] = -2*ind->x[3] - ind->x[4] + ind->x[9];
	ind->g[7] = -2*ind->x[5] - ind->x[6] + ind->x[10];
	ind->g[8] = -2*ind->x[7] - ind->x[8] + ind->x[11];

	ind->factible = 1;
	for (i = 0; i < NUMCONSTR; i++) {
		if (i < NUMCONSTR - NUMEQCONSTR) {
			if (ind->g[i] > 0) {
				ind->factible = 0;
				break;
			}
		}
		else {
			if (fabs(ind->g[i]) - delta > 0) {
				ind->factible = 0;
				break;
			}
		}
	}
}
